#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire300eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 300"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight3004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight3004xi = {
                1:'-101x-37y-279z',
                2:'-101x-90y-267z',
                3:'-105x-32y-278z',
                4:'-108x-190y-205z',
                5:'-108x-218y-174z',
                6:'-108x-86y-265z',
                7:'-10x-96y-283z',
                8:'-110x-27y-277z',
                9:'-113x-276y-20z',
                10:'-114x-22y-276z',
                11:'-115x-82y-264z',
                12:'-117x-16y-275z',
                13:'-119x-185y-202z',
                14:'-11x-51y-295z',
                15:'-120x-214y-171z',
                16:'-121x-10y-274z',
                17:'-121x-77y-263z',
                18:'-127x-270y-17z',
                19:'-127x-72y-261z',
                20:'-130x-181y-200z',
                21:'-132x-209y-169z',
                22:'-133x-66y-260z',
                23:'-139x-60y-258z',
                24:'-140x-175y-198z',
                25:'-141x-263y-14z',
                26:'-144x-203y-166z',
                27:'-144x-54y-257z',
                28:'-149x-47y-255z',
                29:'-150x-169y-196z',
                30:'-154x-40y-254z',
                31:'-155x-196y-164z',
                32:'-155x-256y-11z',
                33:'-15x-53y-294z',
                34:'-161x-162y-193z',
                35:'-166x-189y-161z',
                36:'-168x-247y-8z',
                37:'-16x-98y-282z',
                38:'-170x-155y-191z',
                39:'-177x-181y-159z',
                40:'-180x-147y-189z',
                41:'-181x-238y-5z',
                42:'-188x-173y-156z',
                43:'-189x-138y-186z',
                44:'-193x-228y-2z',
                45:'-197x-129y-184z',
                46:'-198x-164y-154z',
                47:'-19x-55y-294z',
                48:'-205x-120y-182z',
                49:'-205x-218y0z',
                50:'-207x-154y-151z',
                51:'-20x-200y-221z',
                52:'-213x-110y-179z',
                53:'-216x-144y-149z',
                54:'-21x-230y-190z',
                55:'-220x-99y-177z',
                56:'-225x-133y-146z',
                57:'-227x-88y-174z',
                58:'-22x-100y-281z',
                59:'-22x-296y-38z',
                60:'-233x-122y-143z',
                61:'-233x-77y-172z',
                62:'-238x-65y-170z',
                63:'-23x-57y-293z',
                64:'-240x-110y-141z',
                65:'-243x-53y-167z',
                66:'-247x-40y-165z',
                67:'-247x-98y-138z',
                68:'-250x-27y-162z',
                69:'-253x-85y-135z',
                70:'-258x-72y-133z',
                71:'-263x-59y-130z',
                72:'-27x-58y-292z',
                73:'-28x-102y-280z',
                74:'-2x-44y-296z',
                75:'-30x-201y-219z',
                76:'-31x-59y-292z',
                77:'-33x-230y-188z',
                78:'-34x-103y-279z',
                79:'-36x-60y-291z',
                80:'-37x-295y-35z',
                81:'-40x-103y-278z',
                82:'-41x-201y-217z',
                83:'-41x-61y-290z',
                84:'-45x-61y-290z',
                85:'-46x-230y-186z',
                86:'-47x-104y-277z',
                87:'-50x-60y-289z',
                88:'-52x-201y-215z',
                89:'-53x-103y-276z',
                90:'-53x-293y-32z',
                91:'-56x-60y-288z',
                92:'-58x-229y-183z',
                93:'-5x-46y-296z',
                94:'-60x-103y-275z',
                95:'-61x-59y-287z',
                96:'-64x-200y-213z',
                97:'-66x-57y-286z',
                98:'-67x-102y-273z',
                99:'-68x-290y-29z',
                100:'-6x-296y-41z',
                101:'-71x-227y-181z',
                102:'-71x-56y-285z',
                103:'-74x-100y-272z',
                104:'-75x-198y-211z',
                105:'-76x-53y-284z',
                106:'-7x-125y-379z',
                107:'-81x-51y-284z',
                108:'-81x-98y-271z',
                109:'-83x-225y-179z',
                110:'-83x-286y-26z',
                111:'-86x-196y-209z',
                112:'-86x-48y-283z',
                113:'-88x-96y-270z',
                114:'-8x-49y-295z',
                115:'-91x-45y-282z',
                116:'-95x-93y-268z',
                117:'-96x-222y-176z',
                118:'-96x-41y-280z',
                119:'-97x-193y-207z',
                120:'-98x-282y-23z',
                121:'-9x-199y-223z',
                122:'-9x-229y-193z',
                123:'0x-41y-297z'}

#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire300eight4xi" usage = "target function for charge300eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire300eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE300EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE300EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE300EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE300EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE300EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight3004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE300EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE300EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE300EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight3004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight3004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE300EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE300EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE300EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire300eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  